using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;   

namespace InheritedGridControl
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
        }

        void Form1_Load(object sender, EventArgs e)
        {
            this.gridControl1.ContextMenuClick += new MyGridControl.objContextMenuClick(gridControl1_ContextMenuClick); 
        }

        void gridControl1_ContextMenuClick(object sender, EventArgs e)
        {
            MenuItem menu = sender as MenuItem;
            MessageBox.Show(menu.Text + " is clicked.."); 
        }
    }
    public class MyGridControl : GridControl
    {
        public delegate void objContextMenuClick(object sender ,EventArgs e); 
        public event objContextMenuClick ContextMenuClick;

        public MyGridControl()
        {
            ContextMenu menu = new ContextMenu();
            
            menu.MenuItems.Add("Copy");
            menu.MenuItems.Add("Paste");
            menu.MenuItems.Add("Edit");

            for(int i = 0;i< menu.MenuItems.Count;i++)
                menu.MenuItems[i].Click += new EventHandler(OnContextMenuClick); 

            this.ContextMenu = menu;
        }

        void OnContextMenuClick(object sender, EventArgs e)
        {
            if (ContextMenuClick != null)
            {
                ContextMenuClick(sender, e); 
            }
        }
    }
}